var article = "index.html";
var historyButton = false;

function include(filename, onload) {
    var head = document.getElementsByTagName('head')[0];
    var script = document.createElement('script');
    script.src = filename;
    script.type = 'text/javascript';
    script.onload = script.onreadystatechange = function() {
        if (script.readyState) {
            if (script.readyState === 'complete' || script.readyState === 'loaded') {
                script.onreadystatechange = null;
                onload();
            }
        }
        else {
            onload();
        }
    };
    head.appendChild(script);
}

include('javascript/jquery.min.js', function() {
   $(window).on("load", function() {

      // Load standalone styles from stylesheet at runtime if no TOC
      if (!$(".toc")[0]) {
         var stylesheet=document.createElement('link');
         stylesheet.href='css/standalone.css';
         stylesheet.rel='stylesheet';
         stylesheet.type='text/css';
         (document.head||document.documentElement).appendChild(stylesheet);
         return false;
      }

      $('.section').first().addClass('section-main');
      $('.titlepage').first().attr('id', 'header');

      $("div[class^='toc-level-']").click(function(e){
         var tocLevel = ($(this).attr('class'));
         $('dl.' + tocLevel).slideToggle();
      });

      $('.toc-link').click(function(){
         loadArticle($(this).attr('href'));
         $(".toc-root-item").removeClass("toc-selected-item");
         $(".toc-child-item").removeClass("toc-selected-item");
         $(this).parents().eq(1).addClass("toc-selected-item");
         return false;
      });

      // MSIE patch: MSIE not supporting modern features like "includes" or
      // "destructuring" of arrays. Original code left in comments for future
      // reference
      //if (window.location.href.includes('?')) {
      //   var [url, params] = window.location.href.split('?');
      //   var [key, value]  = params.split('=');
      if (window.location.href.indexOf('?') != -1) {
         //var [url, params] = window.location.href.split('?');
         //var [key, value]  = params.split('=');
         var params = window.location.href.split('?')[1];
         var value = params.split('=')[1];
         loadArticle(value);
      }
      else {
         loadArticle('index.html');
      }

      $(window).on('popstate', function(e) {
         window.historyButton = true;
         loadArticle(e.originalEvent.state.article);
      });

   });
});

function loadArticle(url) {
   // MSIE patch: Code left in comments for future reference (see details above)
   //var [article, hash] = url.split('#');
   var article = url.split('#')[0];
   var hash = url.split('#')[1];
   window.article = article;
   $('.section-main').load(url + ' .section', function () {
      if (hash) {
         //location.hash = '#' + hash;
         $(".section-main").animate({
            scrollTop: $(".section-main").scrollTop() + $("a[name='" + hash + "']").position().top - parseInt($("a[name='" + hash + "']").parent().css('margin-top'))
         }, 0);
      }
      else {
         $(".section-main").animate({ scrollTop: 0 }, 0);
      }

      // Link handler for links in article pages loaded from TOC
      $('.title').has('a').hover(function(){ $(this).toggleClass('mouse-over'); });
      $('.title').has('a').click(function(e) {
         e.stopPropagation();
         var link = window.article + '#' +  $('a', this).attr('name')
         loadArticle(link);
      });

      // Link handler for links in article pages loaded from TOC
      $('.link, .xref').click(function() {
         loadFromLinkInArticle($(this));
         return false;
      });

      if (! window.historyButton) {
         history.pushState({article: url}, '', location.protocol + '//' + location.host + location.pathname + '?_href=' + url);
      }
      window.historyButton = false
      $('body').css('pointer-events', 'all');

   });
}

function loadFromLinkInArticle(link) {
   title = $(link).attr('title');
   chapter = title.substring(0, title.indexOf("."));
   chapter = title.match(/^(\d+).*$/)[1];
   if (title.match(/^\d+\.(\d+).*$/)) {
      subchapter = title.match(/^\d+\.(\d+).*$/)[1];
   }
   else {
      subchapter = 0;
   }

   //$("dl[class^='toc-level-']").slideUp();
   $(".toc-root-item").removeClass("toc-selected-item");
   $(".toc-child-item").removeClass("toc-selected-item");
   if (subchapter > 0) {
      $("dl.toc-level-" + chapter).slideDown();
      $("div.toc-level-" + chapter + "\\." + subchapter + " > div.toc-child-item").addClass("toc-selected-item");
      $('div.toc').animate({
         scrollTop: $("div.toc-level-" + chapter + "\\." + subchapter).offset().top -400
      }, 2000);
   }
   else {
      //$("div:contains('Section " + chapter + "')").parents().eq(0).addClass("toc-selected-item");
      $("div.toc-level-" + chapter + " > div.toc-root-item").addClass("toc-selected-item");
      $('div.toc').animate({
         scrollTop: $("div.toc-level-" + chapter).offset().top -200
      }, 2000);
   }
   loadArticle($(link).attr('href'));
   return false;
}
